image: python:3.10


build-job:
  stage: build
  script:
    - echo "Hello, $GITLAB_USER_LOGIN!"
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'


# Change pip's cache directory to be inside the project directory since we can
# only cache local items.
variables:
  PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"

# Pip's cache doesn't store the python packages
# https://pip.pypa.io/en/stable/reference/pip_install/#caching
#
# If you want to also cache the installed packages, you have to install
# them in a virtualenv and cache it as well.
cache:
  paths:
    - .cache/pip
    - venv/

before_script:
  - python --version
  - pip install virtualenv
  - virtualenv venv
  - source venv/bin/activate
  - pip install -r requirements.txt


test-dataset-loading:
  stage: test
  script:
    - echo "Testing dataset loading..."
    - python code_switching_machine_translation/dataset.py
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'



lint-test-dataset:   
  stage: test    
  script:
    - echo "Lintest starting"
    - flake8 code_switching_machine_translation/dataset.py
    - echo "No lint issues found."

  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'



lint-test-model:   
  stage: test    
  script:
    - echo "Lintest starting"
    - flake8 models/models.py
    - echo "No lint issues found."

  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'



# run_pipeline:   # This job also runs in the test stage.
#   stage: test   # It can run at the same time as unit-test-job (in parallel).
#   script:
#     - dvc repro
